3 # Copyright (c) 2006 - 2011 Kungliga Tekniska Högskolan
4 # (Royal Institute of Technology, Stockholm, Sweden).
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
11 # 1. Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
14 # 2. Redistributions in binary form must reproduce the above copyright
15 # notice, this list of conditions and the following disclaimer in the
16 # documentation and/or other materials provided with the distribution.
18 # 3. Neither the name of the Institute nor the names of its contributors
19 # may be used to endorse or promote products derived from this software
20 # without specific prior written permission.
22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
25 # ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
34 top_builddir
="@top_builddir@"
35 env_setup
="@env_setup@"
40 KRB5_CONFIG
="${1-${objdir}/krb5.conf}"
43 testfailed
="echo test failed; cat messages.log; exit 1"
45 # If there is no useful db support compiled in, disable test
52 kadmin
="${kadmin} -l -r $R"
53 kdc
="${kdc} --addresses=localhost -P $port"
55 server
=host
/datan.
test.h5l.se
56 cache
="FILE:${objdir}/cache.krb5"
57 acache
="FILE:${objdir}/acache.krb5"
59 kinit
="${kinit} -c $cache ${afs_no_afslog}"
60 akinit
="${kinit} -c $acache ${afs_no_afslog}"
61 klist
="${klist} -c $cache"
62 aklist
="${klist} -c $acache"
63 kgetcred
="${kgetcred} -c $cache"
64 kdestroy
="${kdestroy} -c $cache ${afs_no_unlog}"
73 echo Creating database
76 --realm-max-ticket-life=1day \
77 --realm-max-renewable-life=1month \
80 ${kadmin} add
-p foo
--use-defaults foo@
${R} ||
exit 1
81 ${kadmin} add -p foo --use-defaults ${server}@${R} ||
exit 1
83 echo "Doing database check"
84 ${kadmin} check
${R} ||
exit 1
86 echo foo
> ${objdir}/foopassword
87 echo bar
> ${objdir}/barpassword
89 echo Starting kdc
; > messages.log
90 env MallocStackLogging
=1 MallocStackLoggingNoCompact
=1 MallocErrorAbort
=1 MallocLogFile
=${objdir}/malloc-log \
91 ${kdc} --detach --testing ||
{ echo "kdc failed to start"; cat messages.log
; exit 1; }
94 trap "kill -9 ${kdcpid}; echo signal killing kdc; cat messages.log; exit 1;" EXIT
102 echo "Getting client initial tickets"; > messages.log
103 ${kinit} --password-file=${objdir}/foopassword foo@
$R || \
104 { ec
=1 ; eval "${testfailed}"; }
105 echo "Checking for FAST avail"
106 ${klist} --hidden |
grep fast_avail
> /dev
/null ||
{ exit 1; }
107 echo "Getting tickets"; > messages.log
108 ${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
109 echo "Listing tickets"; > messages.log
110 ${klist} > /dev/null || { ec=1 ; eval "${testfailed}"; }
113 echo "Acquire host ticket to be used as an ARMOR ticket"; > messages.log
114 ${akinit} --password-file=${objdir}/foopassword ${server}@${R} >/dev/null|| { exit 1; }
115 echo "Checking for FAST avail (in the FAST armor cache)"; > messages.log
116 ${aklist} --hidden |
grep fast_avail
> /dev
/null ||
{ exit 1; }
122 echo "Getting client initial tickets with FAST armor ticket"; > messages.log
123 ${kinit} --fast-armor-cache=${acache} \
124 --password-file=${objdir}/foopassword foo@
$R || \
125 { ec
=1 ; eval "${testfailed}"; }
127 echo "Getting client initial tickets with FAST armor ticket [failure]"; > messages.log
128 ${kinit} --fast-armor-cache=${acache} \
129 --password-file=${objdir}/barpassword foo@
$R 2>/dev
/null
&& \
130 { ec
=1 ; eval "${testfailed}"; }
132 echo "Checking for FAST avail (in the FAST acquired cache)"; > messages.log
133 ${klist} --hidden |
grep fast_avail
> /dev
/null ||
{ exit 1; }
135 echo "Getting service ticket"
136 ${kgetcred} ${server}@${R} || { exit 1; }
140 # Test GSS-API pre-authentication using SAnon. It will only succeed where there
141 # is FAST armor to authenticate the KDC, otherwise it will fail as SAnon does
142 # not provide mutual authentication (GSS_C_MUTUAL_FLAG).
145 for mech
in sanon-x25519 spnego
; do
146 echo "Trying ${mech} pre-authentication with FAST armor"; > messages.log
147 ${kinit} --fast-armor-cache=${acache} \
148 --anonymous --gss-mech=${mech} @
$R 2>/dev
/null || \
149 { ec
=1 ; eval "${testfailed}"; }
151 echo "Getting service ticket"
152 ${kgetcred} ${server}@${R} || { exit 1; }
155 echo "Trying ${mech} pre-authentication with anonymous FAST armor"; > messages.log
156 ${kinit} --pk-anon-fast-armor \
157 --anonymous --gss-mech=${mech} @
$R 2>/dev
/null || \
158 { ec
=1 ; eval "${testfailed}"; }
160 echo "Getting service ticket"
161 ${kgetcred} ${server}@${R} || { exit 1; }
164 echo "Trying ${mech} pre-authentication with no FAST armor"; > messages.log
166 --anonymous --gss-mech=${mech} @
$R 2>/dev
/null
&& \
167 { ec
=1 ; eval "${testfailed}"; }
171 # Use MIT client tools
174 mit
=/usr
/local
/mitkerberos
/bin
176 if [ -f ${mit}/kinit
] ; then
177 echo "Running MIT FAST tests"
179 kinitpty
=${objdir}/foopassword.rkpty
180 cat > ${kinitpty} <<EOF
185 echo "Acquire host ticket"; > messages.log
186 ${rkpty} ${kinitpty} ${mit}/kinit -c ${acache} ${server}@${R} >/dev/null|| { exit 1; }
187 (${aklist} | grep ${server} > /dev/null ) || { exit 1; }
189 echo "Checking for FAST avail"; > messages.log
190 ${aklist} --hidden |
grep fast_avail
> /dev
/null ||
{ exit 1; }
192 echo "Using plain to get a initial ticket"; > messages.log
193 ${rkpty} ${kinitpty} ${mit}/kinit -c ${cache} foo@${R} >/dev/null|| { exit 1; }
194 (${klist} |
grep foo
> /dev
/null
) ||
{ exit 1; }
196 echo "Using FAST to get a initial ticket"; > messages.log
197 ${rkpty} ${kinitpty} ${mit}/kinit -c ${cache} -T ${acache} foo@${R} >/dev/null || { exit 1; }
198 (${klist} |
grep foo
> /dev
/null
) ||
{ exit 1; }
200 echo "Checking for FAST avail"; > messages.log
201 ${klist} --hidden |
grep fast_avail
> /dev
/null ||
{ exit 1; }
203 echo "Getting service ticket"; > messages.log
204 ${mit}/kvno -c ${cache} ${server}@${R} || { exit 1; }
209 echo "killing kdc (${kdcpid})"
210 sh
${leaks_kill} kdc
$kdcpid ||
exit 1